#include <stdio.h>

void error (void)

{
printf ("ERROR: The uncompressing routine branched into an area it wasn't supposed to\n");
printf ("branch to. This could mean that the uncompressor is bugged. Send me a mail and\n");
printf ("i'll look into it as soon as i can.\n\nPress any key to continue.\n");
getch();
}


void deal_with_possible_error(void * pointer)
{
if (pointer == NULL)
        {
        printf ("ERROR: Unexpected null pointer. Possible causes:\n  ->memory allocation error\n  ->error opening file\n");
        getch();
        }
}


void main (int argc, char**argv)
{
/* The code is very messy, since it was taken from TREMAN routine, which
 * looks like spaghetti code (that's what happens when you do things in a
 * hurry)
 */

FILE * tre,*f;
long section1_offset;
long section2_offset;
long section3_offset;
long end_of_header_offset;
char * header;
long number;
long offset,size,CRC,compressed_size;
char * file_crc;
char * data;
char choice;
char buffer2[272];
char string[200];
int i,temp;
long compr_size;
char * compr, * uncompr;
char * b;
long size_of_tre;

if (argc < 2)
        {
        printf ("You must supply a file name as the parameter\n");
        return;
        }

tre = fopen (argv[1],"rb");
if (tre == NULL)
        {
        printf ("ERROR opening file %s\n",argv[1]);
        return;
        }


                        fseek (tre, 8L , SEEK_SET);

                        /* Loading section 0 */

                        fread (&section1_offset,4,1,tre);
                        fread (&section2_offset,4,1,tre);
                        fread (&section3_offset,4,1,tre);
                        fread (&end_of_header_offset,4,1,tre);

                        header = (char *) malloc (end_of_header_offset);
                        deal_with_possible_error ( (void *) header);
                        fseek (tre, 0L , SEEK_SET);
                        fread (header,end_of_header_offset,1,tre);

                        fseek (tre, 0L, SEEK_END);
                        size_of_tre = ftell (tre);

                        /* We have to determine if a given segment of section 1
                         * points us to section2 or section3.
                         */

                        for (i=0;  ;++i)
                                {
                                if ( (section1_offset + i*8) >= section2_offset ) break;
                                CRC =  * (long *) (header + section1_offset + i*8);
                                temp = * (long *) (header + section1_offset + 4 + i*8);

                                if (  temp >= section2_offset && temp < section3_offset  )
                                        {
                                        /* I didn't have time to implement this when i worked on TREMAN
                                         * and then i kinda forgot about it. If you want to implement it
                                         * be my guest :) Be sure to send me a copy tho
                                         */ 
                                        printf ("String files cannot be extracted yet\n");
                                        getch();
                                        }

                                if ( temp >= section3_offset && temp < end_of_header_offset )
                                        {
                                        offset = * (long *) (header + temp);
                                        size = (* (long *) (header + temp + 4)) & 0xffffff;
                                        if ( (temp + 8) < end_of_header_offset)
                                                compr_size = (* (long *) (header + temp + 8) ) - offset;
                                        else
                                                compr_size = size_of_tre - offset;
        
                                        printf ("File %ld - CRC: %lX - Size: %ld - Offset %ld - Compression: %ld, ",i,CRC,size,offset, (long) (100.0 - (( float )compr_size/size *100.0)));
        
                                        if (compr_size != size)
                                                {
                                                compr = (char *) malloc (compr_size);
                                                uncompr = (char *) malloc (size);
                                                deal_with_possible_error ( (void *) compr);
                                                deal_with_possible_error ( (void *) uncompr);
        
                                                *uncompr = 0;

                                                fseek (tre, offset, SEEK_SET);
                                                fread (compr, compr_size,1,tre);
        
                                                //interrupt();
                                                if ( ( (*compr) & 0xe0 ) == 0xe0)
                                                        {
                                                        printf ("TYPE1\n");
                                                        xtre_decompress (compr, uncompr, size, size);
                                                        }
                                                else
                                                        {
                                                        printf ("TYPE2\n");
                                                        b = (char *) malloc (100000);
                                                        deal_with_possible_error(b);
                                                        xtre_decompress_2 (compr, uncompr,size,b);
                                                        free (b);
                                                        }
        
                                                free (compr);
                                                }
        
                                        else
                                                {
                                                printf ("UNPACKED\n");
                                                uncompr = (char *) malloc (size);
                                                deal_with_possible_error ( (void *) uncompr);
                
                                                fseek (tre, offset, SEEK_SET);
                                                fread (uncompr, size,1,tre);
                                                }
        
                                        sprintf (string, "%08ld.iff",i);
                                        f=fopen (string, "wb");
                                        fwrite (uncompr, size, 1,f);
                                        fclose (f);
        
                                        free (uncompr);
                                        }
                                }


fclose (tre);
}
